/**
  * Mozilla Web Engine Abstraction Layer.
  * @file gmozillapassman.c: Mozilla Password Manager Interface Implementation
  * @version $Rev: 2317 $
  * @date $LastChangedDate: 2006-02-14 18:39:46 +0200 (Tue, 14 Feb 2006) $
  *
  * Copyright (C) 2005 - 2006 Nokia Corporation.
  *
  * Contact: Leonid Zolotarev <leonid.zolotarev@nokia.com>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public License
  * as published by the Free Software Foundation; either version 2.1 of
  * the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  * Lesser General Public License for more details.
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  * 02110-1301 USA
  *
  */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "gmozillapassman.h"

static GWebStatus
g_mozilla_password_manager_get_login_username (GMozillaPasswordManager *self, gchar **username)
{
	        return (GWebStatus) 0;
}

static GWebStatus
g_mozilla_password_manager_get_login_password (GMozillaPasswordManager *self, gchar **password)
{
	        return (GWebStatus) 0;
}

static GObject*
g_mozilla_password_manager_login_get_personal_data (GMozillaPasswordManager *self)
{
	return G_MOZILLA_PASSWORD_MANAGER(self)->login;
}

static void
g_mozilla_password_manager_instance_init (GTypeInstance *instance, gpointer  g_class)
{
	G_MOZILLA_PASSWORD_MANAGER(instance)->login = NULL;
}

static void
g_mozilla_password_manager_interface_init (GWebPasswordManagerIface *iface)
{
	iface->get_login_username = (GWebStatus (*) (GWebPasswordManager*, gchar**))
					g_mozilla_password_manager_get_login_username;
	iface->get_login_password = (GWebStatus (*) (GWebPasswordManager*, gchar**))
					g_mozilla_password_manager_get_login_password;
	iface->login_get_personal_data = (GObject* (*) (GWebPasswordManager*))
					g_mozilla_password_manager_login_get_personal_data;
}


GType
g_mozilla_password_manager_get_type (void)
{
    static GType type = 0;
    if (type == 0) {
        static const GTypeInfo info = {
            sizeof (GMozillaPasswordManagerClass),
            NULL,   /* base_init */
            NULL,   /* base_finalize */
            NULL,   /* class_init */
            NULL,   /* class_finalize */
            NULL,   /* class_data */
            sizeof (GMozillaPasswordManager),
            0,      /* n_preallocs */
            g_mozilla_password_manager_instance_init    /* instance_init */
        };
		static const GInterfaceInfo iface_info = {
			(GInterfaceInitFunc) g_mozilla_password_manager_interface_init,
			NULL,   /* interface_finalize */
			NULL    /* interface_data */
		};
		type = g_type_register_static (G_TYPE_OBJECT,
		                               "GMozillaPasswordManager",
		                               &info, (GTypeFlags) 0);
		g_type_add_interface_static (type,
		                             G_TYPE_WEB_PASSWORD_MANAGER,
		                             &iface_info);
    }
    return type;
}

GObject*
g_mozilla_password_manager_login_new (const gchar* server, gint index)
{
	GObject* instance = G_OBJECT(g_object_new(g_mozilla_password_manager_get_type(), NULL));
	G_MOZILLA_PASSWORD_MANAGER(instance)->login = (GObject*)NULL;
	return instance;
}
